public class ChessPlayer implements Comparable<ChessPlayer>{
    public final String name;
    public int elo;

    public ChessPlayer(String name){
        this.name = name;
        this.elo = 0;
    }

    public ChessPlayer(String name, int elo){
        this.name = name;
        this.elo = elo;
    }

    public int compareTo(ChessPlayer other){
	if(this.elo - other.elo == 0){
            return 0;
        }
        return this.elo - other.elo < 0 ? -1 : 1;
    }

    public boolean equals(ChessPlayer other){
        return this.name.equals(other.name) && this.elo==other.elo;
    }

    public int hashCode(){
        return name.hashCode();
    }

    public String toString(){
        return name + ": " + elo;
    }
}
